//+------------------------------------------------------------------+
//|                                   Guppy MMA oscilator binary.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_level1  0
#property indicator_levelcolor DarkSlateGray
#property indicator_maximum  1.1
#property indicator_minimum -1.1

//
//
//
//
//

extern int  Price            = PRICE_CLOSE;
extern int  SignalPeriod     = 13;
extern bool ZeroLineCrosses  = true;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double periods[]={3,5,8,10,12,15,30,35,40,45,50,60};
int    persize;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   persize =ArraySize(periods);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+SignalPeriod);
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double sum  = 0;
      for(int j=0; j<persize; j++)
      {
         if (periods[j]<30)
               sum  += iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
         else  sum  -= iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
      }
      buffer1[i] = 0;
      buffer2[i] = 0;
      buffer3[i] = sum*10.0;
      buffer4[i] = buffer4[i+1]+alpha*(buffer3[i]-buffer4[i+1]);
         if (ZeroLineCrosses)
         {
            if (buffer3[i] > 0) { buffer1[i]= 1; buffer2[i]=-1; }
            if (buffer3[i] < 0) { buffer1[i]=-1; buffer2[i]= 1; }
         }
         else
         {
            if (buffer3[i] > buffer4[i]) { buffer1[i]= 1; buffer2[i]=-1; }
            if (buffer3[i] < buffer4[i]) { buffer1[i]=-1; buffer2[i]= 1; }
         }
               
   }
   
   //
   //
   //
   //
   //
   
   string shortName = "neutral";
         if (buffer1[0] > 0) shortName = "BULLISH";
         if (buffer2[0] > 0) shortName = "BEARISH";
   IndicatorShortName("GMMA oscilator "+shortName);
   return(0);
}